   
use32
   
 org 0x4000
 db 'MENUET02'
START:
   
exec_kill:
 mov eax, 3
 int 0x80
 mov edi, ebx
 add edi, 1
 mov al, ' '
 mov ecx, 55
 push edi
 cld
 repnz scasb
 cmp ecx, 60
 jge ps_error
 pop ebx
 call hexzbin
 mov ecx, [hexrez]
 mov eax, 18
 mov ebx, 2
 int 0x40
 mov ebx, empty_line
 mov eax, 1
 int 0x80
 ret
ps_error:
 pop eax
 mov ebx, ps_par_err
 mov eax, 1
 int 0x80
 ret
   
   
hexzbin:
; string in ebx
 pusha
 mov eax, 0
hex_loop:
 xor edx, edx
 mov dl, [ebx]
 cmp dl, '0'
 jl hex_done
 cmp dl, '9'
 jg hex_letter
 sub dl, '0'
 jmp hex_gen
hex_letter:
 cmp dl, 'F'
 jg hex_small
 sub dl, 'A'
 add dl, 10
 jmp hex_gen
hex_small:
 sub dl, 'a'
 add dl, 10
hex_gen:
 cmp eax, 0x0fffffff
 jg hex_done
 shl eax, 4
 add eax, edx
 inc ebx
 jmp hex_loop
hex_done:
 mov [hexrez], eax
 popa
 ret
   
hexrez dd 0
   
empty_line db 13,0
   
ps_par_err db 13,'Please specify process id!',13,0
   
stdpars dd 0
   
   