   
use32
   
 org 0x4000
 db 'MENUET02'
   
START:
   
   
exec_ls:
 mov [big_data], bigdata
 mov eax, 3
 mov edi, ebx
 add edi, 1
 mov al, ' '
 mov ecx, 50
 push edi
 cld
 repnz scasb
 dec edi
 mov byte [edi], 0
 mov eax, edi
 pop edi
 push eax
 cmp ecx, 49
 jge ls_default
 push edi
 mov esi, ls_par0
 call strzcmp
 pop edi
 cmp byte [strez], 0
 jz no_ls_par0
 pop ebx
 mov byte [ebx], ' '
 mov ebx, empty_line
 mov eax, 1
 int 0x80
 mov ebx, ls_head
 mov eax, 1
 int 0x80
 mov byte [lsphase], 1
 call _print_files
 mov byte [lsphase], 0
 call _print_files
 ret
no_ls_par0:
 push edi
 mov esi, ls_par1
 call strzcmp
 pop edi
 cmp byte [strez], 0
 jz no_ls_par1
 jmp ls_default
no_ls_par1:
 pop ebx
 mov byte [ebx], ' '
 mov ebx, ls_par_err
 mov eax, 1
 int 0x80
 ret
ls_default:
 pop ebx
 mov byte [ebx], ' '
 mov ebx, empty_line
 mov eax, 1
 int 0x80
 mov byte [lsphase], 1
 call print_files
 mov byte [lsphase], 0
 call print_files
 ret
   
print_files:
startfiles:
 mov dword [readblock],1
 mov byte [lstype], 0
startread:
 mov eax,34
 mov ebx,location
 mov ecx,0
 mov edx,[readblock]  ; start block
 mov esi,16           ; number of blocks to read
 mov edi,[big_data]
 int 0x40
 ;cmp eax,0
 jmp readok
 ;jmp readerr0
readok:
; command succesful
 mov esi,[big_data]
 add esi, 1024
 mov edx, 224        ; count
 mov edi,fileinfo
nextfile:
 pusha               ; clear
 mov al,' '
 mov ecx,15
 cld
 rep stosb
 popa
 mov cl,[esi+11]    ; long fat32 name ?
 cmp cl,0xf
 jnz nofat32
 jmp skipfile
nofat32:
 mov cl,[esi+0]     ; deleted file
 cmp cl,0xe5
 jnz nodelfile
 jmp skipfile
nodelfile:
 mov cl,[esi+11]    ; folder
 and cl,0x10
 jz nofolder
 mov byte [lstype], 1
nofolder:
 push edi
 push esi
 mov ecx, 8
filenameloop:
 mov al, [esi]
 cmp al, ' '
 je printext
 mov [edi], al
 inc edi
 inc esi
 loop filenameloop
printext:
 mov byte [edi], '.'
 inc edi
noextshift:
 mov ecx, 8
fileextloop:
 mov al, [esi]
 cmp al, ' '
 jne startextcopy
 inc esi
 loop fileextloop
startextcopy:
 pop eax
 push eax
 mov ebx, esi
 sub esi, eax
 cmp esi, 10
 jge noext
 mov esi, ebx
 mov ecx, 3
 cld
 rep movsb
noext:
 pop esi
 pop edi
checkfile:
 mov al, [lsphase]
 cmp al, [lstype]
 jne inf
wrongphase:
 cmp edi, fileinfo+30
 jg inf1
 add edi, 15
 jmp inf
inf1:
 mov edi, fileinfo
 mov ebx, edi
 mov eax, 1
 int 0x80
inf:
 add esi, 32
 mov byte [lstype], 0
 sub edx,1
 cmp edx,0
 jz nonextfile
 jmp nextfile
nonextfile:
nomorefiles:
 ret
readerr0:
 mov ebx, lserr
 mov eax, 1
 int 0x80
 ret
skipfile:
 jmp inf
   
   
   
_print_files:
_el0:
 mov dword [readblock],1
 mov byte [lstype], 0
_el1_:
 mov  eax,34
 mov  ebx,location
 mov  ecx,0
 mov  edx,[readblock]  ; start block
 mov  esi,16          ; number of blocks to read
 mov  edi,[big_data]
 int  0x40
 ;mov  eax,0
 ;mov  ebx,1024
 ;cmp  eax,0
 ;jz   _la01
 ;jmp  _readerr0
_la01:
 ; command succesful
 mov  esi,[big_data]
 add esi, 1024
 mov  edi,_fileinfo+6
 mov  edx,224
_newlineb:
 pusha      ; clear
 mov  al,' '
 mov  ecx,34
 ;sub  edi,11
 cld
 rep  stosb
 popa
 mov  cl,[esi+11] ; long fat32 name ?
 cmp  cl,0xf
 jnz  _noib1
 mov  [edi-5],dword 'F32 '
 add  esi,32
 jmp  _inf
_noib1:
 mov  eax,'DAT '  ; data or .. ?
 mov  cl,[esi+0]  ; deleted file
 cmp  cl,0xe5
 jnz  _nodelfil
 mov byte [lstype], 2
 mov  eax,'DEL '
 jmp  _ffile
_nodelfil:
 mov  cl,[esi+11] ; folder
 and  cl,0x10
 jz   _ffile
 mov  eax,'FOL '
 mov  [edi-5],eax
 mov  [edi+25],byte ' '
 mov byte [lstype], 1
 jmp  _nosize
_ffile:
 mov  [edi-5],eax
 pusha      ; size
 mov  eax,[esi+28]
 mov  esi,edi
 add  esi,25
 mov  ebx,10
 mov  ecx,8
_newnum:
 xor  edx,edx
 div  ebx
 add  dl,48
 mov  [esi],dl
 cmp  eax,0
 jz   _zernum
 sub  esi,1
 loop _newnum
_zernum:
 popa
_nosize:
 mov  ecx,8    ; first 8
 cld
 rep  movsb
 push esi
 mov esi, edi
 sub esi, 7
 mov ecx, 7
_el3:
 cmp byte [esi], ' '
 je _el4
 cmp byte [esi], 0
 jz _el6
 inc esi
 loop _el3
_el4:
 mov [esi], byte '.'
 mov edi, esi
 inc edi
 pop esi
 mov  ecx,3    ; last 3
 cld
 rep  movsb
 mov al, [lsphase]
 cmp al, [lstype]
 jne _el5
 mov ebx, _fileinfo
 mov eax, 1
 int 0x80
_el5:
 add  esi,(32-11)
_inf:
 mov byte [lstype], 0
 mov edi, _fileinfo+6
 sub  edx,1
 cmp  edx,0
 jz   _nonewlineb
 jmp  _newlineb
_nonewlineb:
_el2:
 ret
_readerr0:
 mov ebx, lserr
 mov eax, 1
 int 0x80
 ret
_el6:
 pop eax
 ret
_el7:
 pop esi
 jmp _el5
   
   
strzcmp:
 pusha
 mov byte [strez], 1
cmploop:
 mov al, [esi]
 mov bl, [edi]
 cmp al, bl
 je cmpok
 cmp al, 0
 jnz cmpend1
 cmp bl, 0
 jnz cmpend1
 jmp cmpend
cmpend1:
 mov byte [strez], 0
cmpok:
 cmp al, 0
 jz cmpend
 inc edi
 inc esi
 jmp cmploop
cmpend:
 popa
 ret
   
   
strez db 0
   
empty_line db 13,0
   
lstype db 0
lsphase db 0
   
readblock dd 1
   
location db '/           /           /           /           '
   
fileinfo:
    db   '                              '
    db   '                             !'
    db 13,0,0
_fileinfo:
    db   '                                         ',13,0,0
   
lserr db 13,'File system error!',13,0
   
ls_head db ' TYPE  NAME                   SIZE   ',13
        db '-------------------------------------',13,0
   
ls_par0 db '-l',0
ls_par1 db '-s',0
ls_par_err db 13,'Invalid parameter(s) specified!',13,0
   
   
big_data dd 0
   
bigdata:
   
   